# Introduction to ]po[ Petri-Net Workflows 
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](https://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](https://www.project-open.com/en/list-installers)

About Introduction to ]po[ Petri-Net Workflows :

<p>This document provides a quick overview of contents of the ]project-open[ workflow <a href="/en/object-type-apm-package">package</a>. 

# Online Reference Documentation

## What is a Workflow?



## Elements of a Workflow



## Workflows and Business Objects



## Starting a Workflow for a ]project-open[ Objects



## The Inbox - Interacting With Users



## Assignments - Who Should Take Action?



## Panels - Working with User Input



## Callbacks - Taking Action



## Pre-configured Workflows



## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=11907&amp;path=packages/acs-workflow/tcl/display-procs.tcl">tcl/display-procs.tcl</a></b></td><td></td><td>Procs to render workflow information in HTML. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/tcl/expenses-procs.tcl">tcl/expenses-procs.tcl</a></b></td><td></td><td>Procs to render workflow information in HTML. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=11907&amp;path=packages/acs-workflow/tcl/graph-procs.tcl">tcl/graph-procs.tcl</a></b></td><td></td><td>Helper procs for generating graphical representations of workflows. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=11907&amp;path=packages/acs-workflow/tcl/intranet-workflow-procs.tcl">tcl/intranet-workflow-procs.tcl</a></b></td><td></td><td>]project-open[ specific extension for acs-workflow. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=11907&amp;path=packages/acs-workflow/tcl/wizard-procs.tcl">tcl/wizard-procs.tcl</a></b></td><td></td><td>Helper-procs for the process wizard. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/procs-file-view?version_id=11907&amp;path=packages/acs-workflow/tcl/workflow-procs.tcl">tcl/workflow-procs.tcl</a></b></td><td></td><td>Tcl-API for the workflow engine. </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_action_pretty">wf_action_pretty</a></b></td><td></td><td>Returns the pretty version of a task action. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_arc">wf_add_arc</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_arc_in">wf_add_arc_in</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_arc_out">wf_add_arc_out</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_place">wf_add_place</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_role">wf_add_role</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_trans_attribute_map">wf_add_trans_attribute_map</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_trans_role_assign_map">wf_add_trans_role_assign_map</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_add_transition">wf_add_transition</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_assignment_widget">wf_assignment_widget</a></b></td><td></td><td>Returns an HTML fragment containing a form element for entering the value of an attribute. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_attribute_value_pretty">wf_attribute_value_pretty</a></b></td><td></td><td>Returns a nice display version of the value of an attribute. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_attribute_widget">wf_attribute_widget</a></b></td><td></td><td>Returns an HTML fragment containing a form element for entering the value of an attribute. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_add_manual_assignment">wf_case_add_manual_assignment</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_add_task_assignment">wf_case_add_task_assignment</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_cancel">wf_case_cancel</a></b></td><td></td><td>Cancels a case </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_clear_manual_assignments">wf_case_clear_manual_assignments</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_clear_task_assignments">wf_case_clear_task_assignments</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_comment">wf_case_comment</a></b></td><td></td><td>Comment on a case </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_info">wf_case_info</a></b></td><td></td><td>Get information about a case. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_new">wf_case_new</a></b></td><td></td><td>Creates and initializes a case of the given workflow type. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_remove_case_deadline">wf_case_remove_case_deadline</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_remove_manual_assignment">wf_case_remove_manual_assignment</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_remove_task_assignment">wf_case_remove_task_assignment</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_resume">wf_case_resume</a></b></td><td></td><td>Resumes a suspended case </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_set_case_deadline">wf_case_set_case_deadline</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_set_manual_assignments">wf_case_set_manual_assignments</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_set_task_assignments">wf_case_set_task_assignments</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_case_suspend">wf_case_suspend</a></b></td><td></td><td>Suspends a case </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_decorate_workflow">wf_decorate_workflow</a></b></td><td></td><td>Adds linking information to the workflow net, based on the arguments given. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_delete_arc">wf_delete_arc</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_delete_place">wf_delete_place</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_delete_role">wf_delete_role</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_delete_trans_attribute_map">wf_delete_trans_attribute_map</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_delete_trans_role_assign_map">wf_delete_trans_role_assign_map</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_delete_transition">wf_delete_transition</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_expenses_get_assign_panels">wf_expenses_get_assign_panels</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_export_workflow">wf_export_workflow</a></b></td><td></td><td>Generates a SQL script that can re-create this process in another installation. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_generate_dot_representation">wf_generate_dot_representation</a></b></td><td></td><td>Generates a dot-file for use with Graphviz. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_get_workflow_net">wf_get_workflow_net</a></b></td><td></td><td>We cache the workflow net, although we don&#39;t really need that anymore. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_get_workflow_net_internal">wf_get_workflow_net_internal</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_graphviz_dot_exec">wf_graphviz_dot_exec</a></b></td><td></td><td>Implementation of wf_graphviz_dot_exec. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_graphviz_installed_p">wf_graphviz_installed_p</a></b></td><td></td><td>Will tell you whether the AT&amp;T GraphViz package is installed or not. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_if_null">wf_if_null</a></b></td><td></td><td>If string is emtpy, returns &lt;code&gt;value_if_null&lt;/code&gt;, otherwise returns string. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_ismap_to_client_map">wf_ismap_to_client_map</a></b></td><td></td><td>Translates a server-side imagemap as generated by graphviz into a client-side imagemap that you can include in your HTML. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_journal">wf_journal</a></b></td><td></td><td>Get the journal for a case. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_make_unique">wf_make_unique</a></b></td><td></td><td>Takes a name (split in two parts) and makes it unique with respect to the list passed in &lt;code&gt;taken_names&lt;/code&gt;, by putting an integer number between &lt;code&gt;name_part_one&lt;/code&gt; and &lt;code&gt;name_part_two&lt;/code&gt;, chopping &lt;code&gt;name_part_one&lt;/code&gt; as required to stay within maxlen. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_message_transition_fire">wf_message_transition_fire</a></b></td><td></td><td>Fires a message transition. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_move_role_down">wf_move_role_down</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_move_role_up">wf_move_role_up</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_name_to_key">wf_name_to_key</a></b></td><td></td><td>Generates a key from a name by making it all lowercase, removing non-letters and putting in underscores instead of spaces. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_new_journal">wf_new_journal</a></b></td><td></td><td>Creates a new journal entry that can be passed to PL/SQL routines </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_progress_bar">wf_progress_bar</a></b></td><td></td><td>Returns an HTML fragment that displays the progress of a wizard nicely. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_simple_wizard_process_def">wf_simple_wizard_process_def</a></b></td><td></td><td>Gives the process definition list for use with &lt;code&gt;wf_progress_bar&lt;/code&gt; </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_simple_workflow_p">wf_simple_workflow_p</a></b></td><td></td><td>Returns whether the workflow is &quot;almost linear&quot; or not. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_split_query_url_to_arg_spec">wf_split_query_url_to_arg_spec</a></b></td><td></td><td>Splits a URL including query arguments (e.g., /foo/bar?baz=greble&amp;yank=zazz) up into a list of lists of name/value pairs, that can be passed as an argument to export_vars. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_sweep_message_transition_tcl">wf_sweep_message_transition_tcl</a></b></td><td></td><td>Sweep those message transitions that have a TCL callback and advance the transitions. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_sweep_time_events">wf_sweep_time_events</a></b></td><td></td><td>Sweep timed transitions and hold timeouts. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_task_action">wf_task_action</a></b></td><td></td><td>Tells the workflow engine that the given action has been taken. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_task_actions">wf_task_actions</a></b></td><td></td><td>Returns a list of the possible actions given the task state. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_task_info">wf_task_info</a></b></td><td></td><td>Get detailed information about one task. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_task_list">wf_task_list</a></b></td><td></td><td>Get information about the tasks are on a user&#39;s work list. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_task_panels">wf_task_panels</a></b></td><td></td><td>Add the panels for a task into the multirow target. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_task_state_pretty">wf_task_state_pretty</a></b></td><td></td><td>Returns a pretty-print version of a task state. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_valid_key_p">wf_valid_key_p</a></b></td><td></td><td>Check that a value is valid as a key for a workflow/transition/place in a workflow definition. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_wizard_massage_tasks">wf_wizard_massage_tasks</a></b></td><td></td><td>We store tasks in a client property as a list of array gets with the keys: task_name, transition_key, task_time, loop_to_transition_key, loop_question, loop_answer, assigning_transition_key. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_workflow_changed">wf_workflow_changed</a></b></td><td></td><td>Flushes the cache. </td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/proc-view?version_id=11907&amp;proc=wf_workflow_info">wf_workflow_info</a></b></td><td></td><td>Get the definition of a workflow. </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/acs-workflow-create.sql&amp;version_id=11907">sql/postgresql/acs-workflow-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/acs-workflow-drop.sql&amp;version_id=11907">sql/postgresql/acs-workflow-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/load-workflow.sql&amp;version_id=11907">sql/postgresql/load-workflow.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/sample-article-create.sql&amp;version_id=11907">sql/postgresql/sample-article-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/sample-article-drop.sql&amp;version_id=11907">sql/postgresql/sample-article-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/sample-expenses-create.sql&amp;version_id=11907">sql/postgresql/sample-expenses-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/sample-expenses-drop.sql&amp;version_id=11907">sql/postgresql/sample-expenses-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/test/workflow-case-package-test.sql&amp;version_id=11907">sql/postgresql/test/workflow-case-package-test.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.0-4.0.1.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.0-4.0.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.0.1-4.1b.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.0.1-4.1b.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.1.1-4.3.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.1.1-4.3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.5.0-4.5.1.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.5.0-4.5.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.5.1-4.5.2.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.5.1-4.5.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.5.2-4.5.3.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.5.2-4.5.3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.5.3-4.5.4.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.5.3-4.5.4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.5.4-4.5.6.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.5.4-4.5.6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/upgrade/upgrade-4.5.6-4.5.7.sql&amp;version_id=11907">sql/postgresql/upgrade/upgrade-4.5.6-4.5.7.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/wf-callback-package-body.sql&amp;version_id=11907">sql/postgresql/wf-callback-package-body.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/wf-callback-package-head.sql&amp;version_id=11907">sql/postgresql/wf-callback-package-head.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/wf-callback-package.sql&amp;version_id=11907">sql/postgresql/wf-callback-package.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/wf-core-create.sql&amp;version_id=11907">sql/postgresql/wf-core-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/wf-core-drop.sql&amp;version_id=11907">sql/postgresql/wf-core-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/workflow-case-package-body.sql&amp;version_id=11907">sql/postgresql/workflow-case-package-body.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/workflow-case-package-head.sql&amp;version_id=11907">sql/postgresql/workflow-case-package-head.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/workflow-case-package.sql&amp;version_id=11907">sql/postgresql/workflow-case-package.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/workflow-package-body.sql&amp;version_id=11907">sql/postgresql/workflow-package-body.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/workflow-package-head.sql&amp;version_id=11907">sql/postgresql/workflow-package-head.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="https://www.project-open.net/api-doc/display-sql?package_key=acs-workflow&amp;url=postgresql/workflow-package.sql&amp;version_id=11907">sql/postgresql/workflow-package.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/active-tasks.adp">active-tasks.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/active-tasks.tcl">active-tasks.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>admin/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/arc-add.tcl">arc-add.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/arc-delete.tcl">arc-delete.tcl</a></b></td><td>delete an arc.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/arc-edit-2.tcl">arc-edit-2.tcl</a></b></td><td>Edit arc.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/arc-edit.adp">arc-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/arc-edit.tcl">arc-edit.tcl</a></b></td><td>Edit arc.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/assign-transition-role-2.tcl">assign-transition-role-2.tcl</a></b></td><td>Add assignment of a transition to a role.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/assign-transition-role.adp">assign-transition-role.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/assign-transition-role.tcl">assign-transition-role.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attribute-add-2.tcl">attribute-add-2.tcl</a></b></td><td>Really add the attribute.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attribute-add.adp">attribute-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attribute-add.tcl">attribute-add.tcl</a></b></td><td>Add a workflow attribute.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attribute-delete.tcl">attribute-delete.tcl</a></b></td><td>Delete the attribute.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attributes-table.adp">attributes-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attributes-table.tcl">attributes-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attributes.adp">attributes.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/attributes.tcl">attributes.tcl</a></b></td><td>Manage workflow attributes.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/case-debug.adp">case-debug.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/case-debug.tcl">case-debug.tcl</a></b></td><td>Displays information about a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/cases.adp">cases.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/cases.tcl">cases.tcl</a></b></td><td>View active cases.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/context-add-2.tcl">context-add-2.tcl</a></b></td><td>Add new context.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/context-add.adp">context-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/context-add.tcl">context-add.tcl</a></b></td><td>Add new context.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/define-place-info.adp">define-place-info.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/define-place-info.tcl">define-place-info.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/define-transition-info.adp">define-transition-info.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/define-transition-info.tcl">define-transition-info.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/define.adp">define.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/define.tcl">define.tcl</a></b></td><td>The advanced process builder main page.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/export-2.adp">export-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/export-2.tcl">export-2.tcl</a></b></td><td>Export the definition of a workflow as a SQL script.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/export-download.tcl">export-download.tcl</a></b></td><td>Export the definition of a workflow as a SQL script.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/export.adp">export.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/export.tcl">export.tcl</a></b></td><td>Export the definition of a workflow as a SQL script.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/index.tcl">index.tcl</a></b></td><td>Admin index page.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/init-2.tcl">init-2.tcl</a></b></td><td>Hack to initialize a new case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/init.adp">init.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/init.tcl">init.tcl</a></b></td><td>This page should go away and the applications take care of this themselves.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/name-edit-2.tcl">name-edit-2.tcl</a></b></td><td>Edit name of workflow.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/name-edit.adp">name-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/name-edit.tcl">name-edit.tcl</a></b></td><td>Edit name of workflow.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-add-2.tcl">place-add-2.tcl</a></b></td><td>Add place.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-add.adp">place-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-add.tcl">place-add.tcl</a></b></td><td>Add place.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-delete.tcl">place-delete.tcl</a></b></td><td>Delete place.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-display.adp">place-display.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-display.tcl">place-display.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-edit-2.tcl">place-edit-2.tcl</a></b></td><td>Edit place.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-edit.adp">place-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/place-edit.tcl">place-edit.tcl</a></b></td><td>Edit place.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-add-2.tcl">role-add-2.tcl</a></b></td><td>Adds a role</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-add.adp">role-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-add.tcl">role-add.tcl</a></b></td><td>Adds a role to a workflow</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-delete.tcl">role-delete.tcl</a></b></td><td>Delete role.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-edit-2.tcl">role-edit-2.tcl</a></b></td><td>Edits a role</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-edit.adp">role-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-edit.tcl">role-edit.tcl</a></b></td><td>Edit a role.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-manual-2.tcl">role-manual-2.tcl</a></b></td><td>Make role manually assigned.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-manual.adp">role-manual.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-manual.tcl">role-manual.tcl</a></b></td><td>Makes a role manually assigned</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-move-down.tcl">role-move-down.tcl</a></b></td><td>Move role down.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/role-move-up.tcl">role-move-up.tcl</a></b></td><td>Move role up.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/roles-assignment-table.adp">roles-assignment-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/roles-assignment-table.tcl">roles-assignment-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/roles-table.adp">roles-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/roles-table.tcl">roles-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/static-assignment-add.tcl">static-assignment-add.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/static-assignment-delete.tcl">static-assignment-delete.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/static-assignments-table.adp">static-assignments-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/static-assignments-table.tcl">static-assignments-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/static-assignments.adp">static-assignments.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/static-assignments.tcl">static-assignments.tcl</a></b></td><td>Manage static assignments for a workflow.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-actions-2.tcl">task-actions-2.tcl</a></b></td><td>Update task attributes.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-actions.adp">task-actions.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-actions.tcl">task-actions.tcl</a></b></td><td>Task actions.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-add-2.tcl">task-add-2.tcl</a></b></td><td>Add task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-add.adp">task-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-add.tcl">task-add.tcl</a></b></td><td>Add task</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-assignment-add.tcl">task-assignment-add.tcl</a></b></td><td>Make assignment manual.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-assignment-delete.tcl">task-assignment-delete.tcl</a></b></td><td>Make assignment static for the given transition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-assignment.adp">task-assignment.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-assignment.tcl">task-assignment.tcl</a></b></td><td>Manage assignment of a transition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-attribute-add.tcl">task-attribute-add.tcl</a></b></td><td>Add another attribute to be set by a task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-attribute-delete.tcl">task-attribute-delete.tcl</a></b></td><td>The attribute should not be set by the transition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-attribute-move-up.tcl">task-attribute-move-up.tcl</a></b></td><td>Move up one attribute in the sort_order sequence.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-attributes.adp">task-attributes.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-attributes.tcl">task-attributes.tcl</a></b></td><td>Manage attributes to set during a task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-delete.tcl">task-delete.tcl</a></b></td><td>Delete task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-edit-2.tcl">task-edit-2.tcl</a></b></td><td>Edit task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-edit.adp">task-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-edit.tcl">task-edit.tcl</a></b></td><td>Edit task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-add-2.tcl">task-panel-add-2.tcl</a></b></td><td>Add the panel.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-add.adp">task-panel-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-add.tcl">task-panel-add.tcl</a></b></td><td>Add a task panel.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-delete.tcl">task-panel-delete.tcl</a></b></td><td>Delete the panel.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-edit-2.tcl">task-panel-edit-2.tcl</a></b></td><td>Edit the panel.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-edit.adp">task-panel-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-edit.tcl">task-panel-edit.tcl</a></b></td><td>Edit a task panel.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panel-move-up.tcl">task-panel-move-up.tcl</a></b></td><td>Move up one task panel in the sort_key sequence.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panels.adp">task-panels.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/task-panels.tcl">task-panels.tcl</a></b></td><td>Manage workflow task panels.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/transition-display.adp">transition-display.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/transition-display.tcl">transition-display.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/transition-panels-table.adp">transition-panels-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/transition-panels-table.tcl">transition-panels-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/transitions-table.adp">transitions-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/transitions-table.tcl">transitions-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/unassigned-tasks.adp">unassigned-tasks.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/unassigned-tasks.tcl">unassigned-tasks.tcl</a></b></td><td>List unassigned tasks</td></tr><tr valign="top"><td><b>wizard/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/assignments.adp">assignments.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/assignments.tcl">assignments.tcl</a></b></td><td>Fourth stage of simple process wizard.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/create.adp">create.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/create.tcl">create.tcl</a></b></td><td>Fifth stage of simple process wizard.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/debug.tcl">debug.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/index.tcl">index.tcl</a></b></td><td>Simple process wizard.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/loop-add-2.tcl">loop-add-2.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/loop-add.adp">loop-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/loop-add.tcl">loop-add.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/loop-delete.tcl">loop-delete.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/loops.adp">loops.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/loops.tcl">loops.tcl</a></b></td><td>Third stage of simple process wizard.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/manual-assignment.tcl">manual-assignment.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/new-2.tcl">new-2.tcl</a></b></td><td>Second stage of simple process wizard.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/progress-bar.adp">progress-bar.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/progress-bar.tcl">progress-bar.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/reset-tasks.tcl">reset-tasks.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/static-assignment.tcl">static-assignment.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-add-2.tcl">task-add-2.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-add.adp">task-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-add.tcl">task-add.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-delete.tcl">task-delete.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-edit-2.tcl">task-edit-2.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-edit.adp">task-edit.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-edit.tcl">task-edit.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/task-move.tcl">task-move.tcl</a></b></td><td>Move a task up one step.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/tasks.adp">tasks.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/wizard/tasks.tcl">tasks.tcl</a></b></td><td>Second stage of workflow definition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-add-2.tcl">workflow-add-2.tcl</a></b></td><td>Add new process.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-add.adp">workflow-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-add.tcl">workflow-add.tcl</a></b></td><td>Create new process.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-cases-delete.tcl">workflow-cases-delete.tcl</a></b></td><td>Delete a workflow definition from the system.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-copy-2.tcl">workflow-copy-2.tcl</a></b></td><td>Make a copy of a process.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-copy.adp">workflow-copy.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-copy.tcl">workflow-copy.tcl</a></b></td><td>Make a copy of a process.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-delete.tcl">workflow-delete.tcl</a></b></td><td>Delete a workflow definition from the system.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-display.adp">workflow-display.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-display.tcl">workflow-display.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-dot.tcl">workflow-dot.tcl</a></b></td><td>Returns a graphviz-dot file representation of the workflow.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-graph.adp">workflow-graph.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-graph.tcl">workflow-graph.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-roles.adp">workflow-roles.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-roles.tcl">workflow-roles.tcl</a></b></td><td>Display roles for a workflow</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-summary.adp">workflow-summary.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-summary.tcl">workflow-summary.tcl</a></b></td><td>Displays basic aggregate statistics on a workflow</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-tabs.adp">workflow-tabs.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow-tabs.tcl">workflow-tabs.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow.adp">workflow.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/admin/workflow.tcl">workflow.tcl</a></b></td><td>Index page for a workflow.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/assign-yourself.tcl">assign-yourself.tcl</a></b></td><td>This page assigns a task to the user accessing this page.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/assignee-add-2.tcl">assignee-add-2.tcl</a></b></td><td>Add assignee to task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/assignee-add.adp">assignee-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/assignee-add.tcl">assignee-add.tcl</a></b></td><td>Add assignee</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/assignee-remove-2.tcl">assignee-remove-2.tcl</a></b></td><td>Remove assignee from task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignment-remove-2.tcl">case-assignment-remove-2.tcl</a></b></td><td>Remove manual assignment.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignment-set-2.tcl">case-assignment-set-2.tcl</a></b></td><td>Set case assignments for a role.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignment-set.adp">case-assignment-set.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignment-set.tcl">case-assignment-set.tcl</a></b></td><td>Set case assignments for a role.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignments-table.adp">case-assignments-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignments-table.tcl">case-assignments-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignments.adp">case-assignments.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-assignments.tcl">case-assignments.tcl</a></b></td><td>View/change role assignments for a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-attributes-table.adp">case-attributes-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-attributes-table.tcl">case-attributes-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadline-remove-2.tcl">case-deadline-remove-2.tcl</a></b></td><td>Sets deadline for case transition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadline-set-2.tcl">case-deadline-set-2.tcl</a></b></td><td>Sets deadline for case transition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadline-set.adp">case-deadline-set.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadline-set.tcl">case-deadline-set.tcl</a></b></td><td>Set the deadline for a transition in a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadlines-table.adp">case-deadlines-table.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadlines-table.tcl">case-deadlines-table.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadlines.adp">case-deadlines.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-deadlines.tcl">case-deadlines.tcl</a></b></td><td>Displays deadlines set for a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-state-change.tcl">case-state-change.tcl</a></b></td><td>Change the state of a case</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-state-graph.adp">case-state-graph.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case-state-graph.tcl">case-state-graph.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case.adp">case.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/case.tcl">case.tcl</a></b></td><td>Displays information about a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/comment-add-2.tcl">comment-add-2.tcl</a></b></td><td>Add a comment to the journal for a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/comment-add.adp">comment-add.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/comment-add.tcl">comment-add.tcl</a></b></td><td>Add a comment to the journal for a case.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/finished-tasks.adp">finished-tasks.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/finished-tasks.tcl">finished-tasks.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/index.tcl">index.tcl</a></b></td><td>Displays the user&#39;s task list.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/journal.adp">journal.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/journal.tcl">journal.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>sample/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/sample/expenses-approval-aids.adp">expenses-approval-aids.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/sample/expenses-approval-aids.tcl">expenses-approval-aids.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/sample/expenses-claim-info.adp">expenses-claim-info.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/sample/expenses-claim-info.tcl">expenses-claim-info.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-action.adp">task-action.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-action.tcl">task-action.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-assignees.adp">task-assignees.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-assignees.tcl">task-assignees.tcl</a></b></td><td>Remove one or more assignees for a task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-deadline-set-2.tcl">task-deadline-set-2.tcl</a></b></td><td>Update deadline for a task</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-deadline-set.adp">task-deadline-set.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-deadline-set.tcl">task-deadline-set.tcl</a></b></td><td>Set the deadline for a task</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-default-info.adp">task-default-info.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-default-info.tcl">task-default-info.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-instructions.adp">task-instructions.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-instructions.tcl">task-instructions.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-list.adp">task-list.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task-list.tcl">task-list.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task.adp">task.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/task.tcl">task.tcl</a></b></td><td>Displays information about a specific task.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/test-display.tcl">test-display.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/transition-fire.tcl">transition-fire.tcl</a></b></td><td>Fire a transition.</td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/workflow-gif.tcl">workflow-gif.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="https://www.project-open.net/api-doc/content-page-view?version_id=11907&amp;path=packages/acs-workflow/www/workflow.tcl">workflow.tcl</a></b></td><td>Admin big picture view of a workflow, including places, transitions and arcs</td></tr></table>

